const int button = 2;

int range =2;              // output range of X or Y movement; affects movement speed
int responseDelay = 50;     // response delay of the mouse, in ms
int counter = 0;
int leds[] = {
  4,5,6,7,8,9,10};
int pinCount = 7;

void setup() {

  for (int thisPin = 0; thisPin < pinCount; thisPin++)  {
    pinMode(leds[thisPin], OUTPUT);      
  }    // initialize LEDs{

  pinMode(button, INPUT);   // initialize the buttons' inputs: 
  Mouse.begin();  // initialize mouse control:
}

void loop() {

  // read the buttons:
  while(digitalRead(button) == HIGH) {
    counter++;

    digitalWrite(leds[counter-1], HIGH); 
    digitalWrite(leds[counter-2], LOW);
    Serial.println(counter);
    delay(1000);

    if(digitalRead(button) == LOW) {
      selection(counter); 
    } // end if to send get input selection

    for (int thisPin = 0; thisPin < pinCount; thisPin++)  {
      digitalWrite(leds[thisPin], LOW);      
    } // end for loop for resetting LEDS

    if(counter == 8) {
      counter = 0;
    }

  } // end while loop


} // end void loop()

void selection(int i) {
  int upState = 0;
  int downState = 0;
  int leftState = 0;
  int rightState = 0;
  int clickState = 0;
  int dbl = 0;
  unsigned long interval = 80;
  int j = 0; // counter for timing loop
  
  if(j > 0) {
   j = 0; 
  }
  
  if(i <= 4) {
        
    while(digitalRead(button) == LOW) {

      /* this loop needed to be built this way because using the
      (currentMillis - previousMillis) > interval);
       previousMillis = currentMillis;
      
        seemed to break the loop and would set properly
      
      */
      
      if(j == interval) {
       counter = 0;
        break; 
      } else {
        delay(50);
        j++; 
      } 
      
      // freezes the program to allow user to make input
      // this does nothing
    }

    // calculate the movement distance based on the button states:
    while(digitalRead(button) == HIGH) {
      switch (i) {
      case 1:
        upState = digitalRead(2);
        delay(20);
        Serial.println("Up");
        counter = 0;
        break;      
      case 2:
        downState = digitalRead(2);
        delay(20);
        Serial.println("Down");
        counter = 0;
        break;
      case 3:
        leftState = digitalRead(2);
        delay(20);
        Serial.println("left");
        counter = 0;
        break;
      case 4:
        rightState = digitalRead(2);
        delay(20);
        Serial.println("right");
        counter = 0;
        break;
      default:
        Serial.println("Do Nothing");
        counter = 0;
      } // end switch 

  
  //needed to be altered from original 
  int xDistance = (rightState - leftState)*range;
  int yDistance = (downState - upState)*range;

  // if X or Y is non-zero, move:
  if ((xDistance != 0) || (yDistance != 0)) {
    Mouse.move(xDistance, yDistance, 0);
  }
 } // end while
 
} else if (i>4 && i <= 8) {
  
  while(digitalRead(button)==LOW) {
      if(j == interval) {
       counter = 0;
        break; 
      } else {
        delay(50);
        j++; 
      }
    // pauses loop   
  }
  
  switch(i) {
    case 5: // left click
      if(digitalRead(button) == HIGH) {
      Mouse.click();
      }
      counter = 0;
      delay(1000);
      break;
    case 6: // right click
      if(digitalRead(button) == HIGH) {
      Mouse.press(MOUSE_RIGHT);
      Mouse.release(MOUSE_RIGHT);
      }
      counter = 0;
      delay(1000);
      break;
    case 7:
      if(digitalRead(button) == HIGH) {
      while(dbl <= 1) {
       Mouse.click();
       dbl++;
      } // end while
      } // end if
      delay(1000);
      counter = 0;
      break;
     default:
       Serial.println("Do Nothing");
       counter = 0;
       break;
  } // end switch 5 - 7
    
}
  // a delay so the mouse doesn't move too fast:
  delay(responseDelay);

} // end void


